@echo off

setlocal

:: store original JAVA_HOME and CLASSPATH
set "ORIGINAL_JAVA_HOME=%JAVA_HOME%"
set "ORIGINAL_CLASSPATH=%CLASSPATH%"

:: read application properties
set "BATCH_ABSOLUTE_PATH=%~dp0"
set "BATCH_FILE_NAME=%~n0"
set BATCH_PROPERTIES="%BATCH_ABSOLUTE_PATH%%BATCH_FILE_NAME%.properties"

if not exist %BATCH_PROPERTIES% (
    echo %BATCH_PROPERTIES% not found
    exit 1
)

for /F "tokens=1,2 delims==" %%O in ('type %BATCH_PROPERTIES%') do (
    set "%%O=%%P"
)

set "JAVA_HOME=%java.home%"
set JAVA_XMS=%java.xms%
set JAVA_XMX=%java.xmx%
set JAVA_XMX_32=%java.xmx.32%

set APP_MAIN_CLASS=%app.main.class%
set APP_SHOW_CONSOLE=%app.show.console%
set "APP_PARAMS="

if not "%~1"=="" (
    set APP_PARAMS=%*
)

:: prepare Java
pushd .

cd /D "%BATCH_ABSOLUTE_PATH%"
for %%a in (.) do set currentFolderName=%%~na
if %currentFolderName%==bin (
    cd ..
)

echo Working directory: "%cd%"

if "%JAVA_HOME%" == "" (
    echo java.home is empty
    exit 1
) else (
    if "%APP_SHOW_CONSOLE%"=="true" (
        set "JAVA_EXE=%JAVA_HOME%\bin\java.exe"
    ) else (
        set "JAVA_EXE=%JAVA_HOME%\bin\javaw.exe"
    )

    :: check if Java is 32-bit
	for /F "tokens=1,2 delims==" %%O in ('findstr /I "OS_ARCH=" "%JAVA_HOME%\release"') do (
		if %%P == "i586" (
			set JAVA_XMX=%JAVA_XMX_32%
		)
	)
)

set CLASSPATH=.;.\*;.\lib\*;.\addins\*;.\bin;
set JAVA_OPTIONS=-showversion -Xms%JAVA_XMS% -Xmx%JAVA_XMX%
set COMMAND="%JAVA_EXE%" %JAVA_OPTIONS% -classpath "%CLASSPATH%" %APP_MAIN_CLASS% %APP_PARAMS%

:: run application
if "%APP_SHOW_CONSOLE%"=="true" (
    echo Command: %COMMAND%
    start CMD /C CALL %COMMAND%
) else (
    start "office" %COMMAND%
)

popd

:: restore original JAVA_HOME and CLASSPATH
set "CLASSPATH=%ORIGINAL_CLASSPATH%"
set "JAVA_HOME=%ORIGINAL_JAVA_HOME%"

endlocal
goto :EOF